#ifndef _ARGS_H
#define _ARGS_H

#include <stddef.h>

struct kwil_args_t {
    int argc; // copy of the argv length passed to main
    char** argv; // pointer to the argv array passed to main
    int parsed; // the number of arguments parsed so far

    char** filenames;           // filenames to process
    size_t filenames_len;       // number of filenames to process
    size_t filenames_cap;       // allocated capacity of filenames array
};

// Instantiate a kwil_args_t and parse the arguments array for flags and files
extern void kwil_parse_args(struct kwil_args_t* self, int argc, char** argv);
// Free an arguments object's owned memory.
// Does not free the self*.
extern void kwil_free_args(struct kwil_args_t* self);

// Add a filename to the filename array and increase capacity if needed.
extern int kwil_args_add_filename(struct kwil_args_t* self, const char* filename);

// Parse an argument
extern void kwil_args_parse_arg(struct kwil_args_t* self, int at);
// Parse a filename argument
extern void kwil_args_parse_filename(struct kwil_args_t* self, int at);

#endif // !_ARGS_H
